N, M, K = map(int, input().split())
data = {}
protected_storages = set()

for _ in range(M):
    st1, st2 = map(int, input().split())
    if st1 not in data:
        data[st1] = []
    if st2 not in data:
        data[st2] = []
    data[st1].append(st2)
    data[st2].append(st1)

for i in range(K):
    guard_storage, power = map(int, input().split())
    visited = {guard_storage}
    seq = [(guard_storage, 0)]

    while seq:
        cur_way, cur_dist = seq.pop(0)
        if cur_dist > power:
            continue
        protected_storages.add(cur_way)

        for neighbour in data.get(cur_way, []):
            if neighbour not in visited:
                seq.append((neighbour, cur_dist + 1))
                visited.add(neighbour)

protected_storages = sorted(protected_storages)
print(len(protected_storages))

if protected_storages:
    print(' '.join(map(str, protected_storages)))
